# --------------------------------------------------------------------
#
#              ______________________________________
#             |                                      |
#             | Libraty.tcl v2.47  by Mirora         |
#             |                                      |
#             | IRC:   irc.quakenet.org - #Mirora    |
#             | email: Mirora@evilcoders.eu          |
#             | www:   http://mirora.zapto.org                                   |
#             |______________________________________|
#
#
# --------------------------------------------------------------------
# Commands
# --------------------------------------------------------------------
#
#  Public commands
#  ->  ? <keyword>
#
#
#   Admin commands
#  ->  .lib add <keyword> <Definition>  -  Adds a keyword
#  ->  .lib del <keyword>  -  Delete an added keyword
#  ->  .lib list  -  Shows you a list of all added keywords
#
#
# --------------------------------------------------------------------
# Some credits to
# --------------------------------------------------------------------
#
#   Lukemob & t0xor
# 
# --------------------------------------------------------------------
#  Report any bugs/glitches to Mirora in #Mirora @ Quakenet
# --------------------------------------------------------------------


namespace eval lib {

	# Set trigger here
	variable trigger "."
	variable libtrig "\?"


	# Channel Configurations
	variable chan "#channel"
	variable priv "#channel"
	variable key ""


	# Dont edit this <

	variable library "lib.txt"
	variable author "Mirora. <#Mirora @ Quakenet>"
	variable version "2.47"

}

#--------------------------#
#   SCRIPT STARTS HERE     #
#      DO NOT EDIT!        #
#--------------------------#

if {![array exists lib]} {
	array set lib {}
}

bind PUB m|- ${lib::trigger}lib lib:control
bind PUB * ${lib::libtrig} lib:help



proc lib:help {nick host hand chan arg} {
	set sendnick $nick
	set word [lindex [split $arg] 0]
	if {[lindex [split $arg] 1] != ""} { set sendnick [lindex [split $arg] 1] }
	if {[string equal -nocase $chan ${lib::chan}] } {
		if {[lindex [split $arg] 1] != ""} {
			if {[lib:check [lindex [split $arg] 0]] != "0"} {
				puthelp "PRIVMSG $chan :\002$sendnick\002: [lib:check [lindex [split $arg] 0]]"
			} else {
				putserv "NOTICE $nick :No matches found!"
			}
		} else {
			if {[lib:check [lindex [split $arg] 0]] != "0"} {
				puthelp "PRIVMSG $chan :[lib:check [lindex [split $arg] 0]]"
			} else {
				putserv "NOTICE $nick :No matches found!"
			}
		}
	}
	if {[string equal -nocase $chan ${lib::priv}]} {
		if {[lindex [split $arg] 1] != ""} {
			if {[lib:check [lindex [split $arg] 0]] != "0"} {
				puthelp "PRIVMSG $chan :\002$sendnick\002: [lib:check [lindex [split $arg] 0]]"
			} else {
				puthelp "NOTICE $nick :No such help about \"\002${::lib::libtrig} $word\002\""
			}
		} else {
			if {[lib:check [lindex [split $arg] 0]] != "0"} {
				puthelp "PRIVMSG $chan :[lib:check [lindex [split $arg] 0]]"
			} else {
				puthelp "NOTICE $nick :No such help about \"\002${::lib::libtrig} $word\002\""
			}
		}
	}
}



proc lib:control {nick host hand chan arg} {
	if {[file exists ${lib::library}] == "0"} { set x [open ${lib::library} w] ; close $x }
	if {[lindex [split $arg] 0] == ""} { putquick "NOTICE $nick : Library commands : ${lib::trigger}lib add - del - list" }
	if {[lindex [split $arg] 0] == "help"} {  putquick "NOTICE $nick : Library commands : ${lib::trigger}lib add - del - list" }
	if {[lindex [split $arg] 0] == "list"} {
		lib:list $nick
	}
	if {[lindex [split $arg] 0] == "add"} {
		set commnad [lindex [split $arg] 1]
		if {[lindex [split $arg] 2] == ""} { puthelp "NOTICE $nick :Please type: ${lib::trigger}lib add <keyword> <definition> - Add keyword to library list." ; return }
		set idre "[lrange [split $arg] 1 end]"
		if {[lib:check $idre] == ""} {
			putquick "NOTICE $nick :Done."
			return
		}
		if {[lib:check $idre] != ""} { putquick "NOTICE $nick :Keyword is already on library list." ; return }
	}
	if {[lindex [split $arg] 0] == "del"} {
		if {[lindex [split $arg] 1] == ""} { puthelp "NOTICE $nick :Please type: ${lib::trigger}lib del <keyword> - Remove keyword from library list." ; return }
		if {[lib:check [lindex [split $arg] 1]] == ""} { putquick "NOTICE $nick :Keyword is NOT on library database." }
		if {[lib:check [lindex [split $arg] 1]] != ""} {
			putquick "NOTICE $nick :Done. Removed keyword [lindex [split $arg] 1] from library database."
			lib:remove [lindex [split $arg] 1]
		}
	}

}



proc lib:list {nick} {
	set file [open $lib::library r]
	set data [read -nonewline $file]
	close $file
	if {[llength $data] < 1} { putserv "NOTICE $nick :The library list is empty." ; return }
	puthelp "NOTICE $nick :Library:"
	set id 0
	foreach line [split $data \n] {
		if {$line == ""} { continue }
		incr id 1
		puthelp "NOTICE $nick :#$id Keyword:  [lindex [split $line] 0]  - Definition: [join [lrange $line 1 end]]"
	}
	puthelp "NOTICE $nick :End of Library list."
}



proc lib:check {arg} {
	set file [open $lib::library r]
	set data [read -nonewline $file]
	close $file
	set return "0"
	set id 0
	set status 0
	foreach line [split $data "\n"] {
		if {$line == ""} { continue }
		incr id 1
		if {[lindex [split $line] 0] == [lindex [split $arg] 0]} { set return "[lrange [split $line] 1 end]"; break }
	}
	if {[lindex [split $arg] 1] != ""} {
		set file2 [open $lib::library a]
		puts $file2 "$arg"
		close $file2
	}
	return "$return"
}



proc lib:remove {arg} {
	set file [open $lib::library r]
	set data [read -nonewline $file]

	set file2 [open $lib::library w]
	set data2 [read -nonewline $file]

	close $file
	set id 0
	set status 0
	foreach line [split $data \n] {
		if {$line == ""} { continue }
		incr id 1
		if {[lindex [split $line] 0] != [lindex [split $arg] 0]} { puts $file2 "[lrange [split $line] 0 end]" }
	}
	close $file2
}


putlog "library v${lib::version} loaded, Author: ${lib::author}"
